create or replace TRIGGER SJS.A_NYDEX_INSERT
BEFORE INSERT ON SJS.ARREST
FOR EACH ROW
BEGIN
         for i in (SELECT AC.I_ID,AC.AGCY_ORI FROM SJS.ARRESTCHARGES AC WHERE AC.A_ID=:NEW.A_ID AND AGCY_ORI = :NEW.AGCY_ORI)
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.AGCY_ORI,'N','N','N',null,null,null);
         end loop;
END;

/

create or replace TRIGGER SJS.A_NYDEX_UPDATE
BEFORE UPDATE ON SJS.ARREST
FOR EACH ROW
BEGIN
         for i in (SELECT AC.I_ID,AC.AGCY_ORI FROM SJS.ARRESTCHARGES AC WHERE AC.A_ID=:NEW.A_ID AND AGCY_ORI = :NEW.AGCY_ORI)
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.AGCY_ORI,'N','N','N',null,null,null);
         end loop;
END;
/
create or replace TRIGGER SJS.AC_NYDEX_DELETE
BEFORE DELETE ON SJS.ARRESTCHARGES
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.o := NYDEX.NYDEX_AVOID_MUTATE.n;
END;
/

create or replace TRIGGER SJS.AC_NYDEX_DELETE_AD
AFTER DELETE ON SJS.ARRESTCHARGES
BEGIN
  for i in 1 .. NYDEX.NYDEX_AVOID_MUTATE.o.count
  loop
          insert into NYDEX.NYDEX_MOD_LOG values (NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id,'GREEN',null,1,'M',NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.AC_NYDEX_DELETE_BDFER
before DELETE ON SJS.ARRESTCHARGES
for each row
declare
i    number default NYDEX.NYDEX_AVOID_MUTATE.o.count+1;
BEGIN
 
  NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id:=:old.i_id;
  NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori:=:old.agcy_ori;
END;
/

create or replace TRIGGER SJS.AC_NYDEX_INSERT
BEFORE INSERT ON SJS.ARRESTCHARGES
FOR EACH ROW
BEGIN
   insert into NYDEX.NYDEX_MOD_LOG values (:old.i_id,'GREEN',null,1,'M',:old.i_agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.AC_NYDEX_UPDATE
BEFORE UPDATE OF
       LAW_ORDINAL,
       AC_ATTEMPT,
       AC_COUNTS,
       LARC_THEFT,
       ASSAULT_HOMO,
       JUSTIFIABLE,
       SEALED
       ON SJS.ARRESTCHARGES
       FOR EACH ROW
BEGIN
         insert into NYDEX.NYDEX_MOD_LOG values (:OLD.I_ID,'GREEN',null,1,'M',:NEW.AGCY_ORI,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.ACW_NYDEX_DELETE
BEFORE DELETE ON SJS.ARRESTCHARGESWEAPONS
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.o := NYDEX.NYDEX_AVOID_MUTATE.n;
END;
/


create or replace TRIGGER SJS.ACW_NYDEX_DELETE_AD
AFTER DELETE ON SJS.ARRESTCHARGESWEAPONS
BEGIN
  for i in 1 .. NYDEX.NYDEX_AVOID_MUTATE.o.count
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id,'GREEN',null,1,'M',NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.ACW_NYDEX_DELETE_BDFER
BEFORE DELETE ON SJS.ARRESTCHARGESWEAPONS
FOR EACH ROW
declare
i    number default NYDEX.NYDEX_AVOID_MUTATE.o.count+1;
ori varchar2(9);
iid number(23);
BEGIN
  for j in (select i_id,agcy_ori into iid,ori from sjs.arrestcharges where ac_id=:old.ac_id)
  loop
  NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id:=j.i_id;
  NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori:=j.agcy_ori;
  i:=i+1;
  end loop;
END;
/

create or replace TRIGGER SJS.ACW_NYDEX_INSERT
BEFORE INSERT ON SJS.ARRESTCHARGESWEAPONS
FOR EACH ROW
BEGIN
 
 for i  in (SELECT ac.i_id,ac.agcy_ori FROM sjs.arrestcharges ac WHERE ac.ac_id = :new.ac_id)
 loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
 end loop;
END;
/

create or replace TRIGGER SJS.ACW_NYDEX_UPDATE
BEFORE UPDATE ON SJS.ARRESTCHARGESWEAPONS
FOR EACH ROW
BEGIN
 for i  in (SELECT ac.i_id,ac.agcy_ori FROM sjs.arrestcharges ac WHERE ac.ac_id = :new.ac_id)
 loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
 end loop;
END;
/

create or replace TRIGGER SJS.ADD_NYDEX_INSERT
BEFORE INSERT ON SJS.ADDRESS
FOR EACH ROW
BEGIN
         for i in (SELECT I_ID,AGCY_ORI FROM SJS.INCIDENT INC WHERE ADD_ID=:NEW.ADD_ID)
         loop
           insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
         end loop;
         
         
         --for Persodetail addresses
        
        for i in  (
                  SELECT I_ID,AGCY_ORI FROM SJS.incidentpeople
                  where pd_id in (select pd_id from sjs.persondetail where add_id = :new.add_id)
                  )
        loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
        end loop;
        

          --for arrest addresses

        for i in (
              SELECT I_ID,I_AGCY_ORI FROM SJS.arrestcharges
              where (a_id,AGCY_ORI) in (select a_id,AGCY_ORI from sjs.arrest where a_location = :new.add_id)
              )
       loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
       end loop;

          --for employer address update

        for i in (
                SELECT I_ID,AGCY_ORI FROM SJS.incidentpeople
                where pd_id in (select pd_id from sjs.employer where add_id = :new.add_id)
                )
       loop
       insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
       end loop;
END;
/

create or replace TRIGGER SJS.ADD_NYDEX_UPDATE
BEFORE UPDATE OF
       ADD_STREET,
       ADD_BUILDING,
       ADD_APARTMENT,
       ADD_STREET2,
       ADD_CITY,
       STATEID,
       ADD_ZIP,
       CAUTIONID
       ON SJS.ADDRESS
       FOR EACH ROW
BEGIN
         for i in (SELECT I_ID,AGCY_ORI FROM SJS.INCIDENT INC WHERE ADD_ID=:OLD.ADD_ID)
         loop
           insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
         end loop;
         

          --for Persodetail addresses
        for i in  (
                  SELECT I_ID,AGCY_ORI FROM SJS.incidentpeople
                  where pd_id in (select pd_id from sjs.persondetail where add_id = :old.add_id)
                  )
        loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
        end loop;
          --for arrest addresses

        for i in (
              SELECT I_ID,I_AGCY_ORI FROM SJS.arrestcharges
              where (a_id,AGCY_ORI) in (select a_id,AGCY_ORI from sjs.arrest where a_location = :old.add_id)
              )
       loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
       end loop;

          --for employer address update

          for i in (
                SELECT I_ID,AGCY_ORI FROM SJS.incidentpeople
                where pd_id in (select pd_id from sjs.employer where add_id = :old.add_id)
                )
       loop
       insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
       end loop;

END;
/

create or replace TRIGGER SJS.ALS_NYDEX_DELETE
BEFORE DELETE ON SJS.ALIAS
FOR EACH ROW
BEGIN
  
  for i in (
            select i_id,AGCY_ORI from incidentpeople
            where pd_id in
              (
                select pd_id from sjs.persondetail where pm_id=:old.pm_id
              )
          )
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
  end loop;

--for arrestpeople
    
    for i in   (
          select I_ID,I_AGCY_ORI from arrestcharges
          where (A_id,AGCY_ORI)
          IN
          (
          select A_id,AGCY_ORI from arrestpeople
          where pd_id in
          (
          select pd_id from sjs.persondetail where pm_id=:old.pm_id
          )
          )
        )
   loop
   insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
   end loop;
      
--for warrantpeople
 for i in (
          select I_ID,I_AGCY_ORI from warrantcharges
          where (w_id,AGCY_ORI)
          IN
          (
          select w_id,AGCY_ORI from warrantpeople
          where pd_id in
          (
          select pd_id from sjs.persondetail where pm_id=:old.pm_id
          )
          )
        )
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.ALS_NYDEX_INSERT
BEFORE INSERT ON SJS.ALIAS
       FOR EACH ROW
BEGIN
    for i in (
            select i_id,AGCY_ORI from incidentpeople
            where pd_id in
              (
                select pd_id from sjs.persondetail where pm_id=:new.pm_id
              )
          )
    loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
    end loop;

        --for Arrestpeople table
  

    for i in   (
          select I_ID,I_AGCY_ORI from arrestcharges
          where (A_id,AGCY_ORI)
          IN
          (
          select A_id,AGCY_ORI from arrestpeople
          where pd_id in
          (
          select pd_id from sjs.persondetail where pm_id=:new.pm_id
          )
          )
        )
   loop
   insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
   end loop;

         --for WARRANT table
     
      for i in (
          select I_ID,I_AGCY_ORI from warrantcharges
          where (w_id,AGCY_ORI)
          IN
          (
          select w_id,AGCY_ORI from warrantpeople
          where pd_id in
          (
          select pd_id from sjs.persondetail where pm_id=:new.pm_id
          )
          )
        )
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.ALS_NYDEX_UPDATE
BEFORE UPDATE OF
       ALIAS_LAST_NAME,
       ALIAS_FIRST_NAME,
       ALIAS_MIDDLE_NAME,
       ALIAS_SUFFIX,
       ALIAS_DOB,
       ALIAS_SSN
       ON SJS.ALIAS
       FOR EACH ROW
BEGIN
      for i in (
            select i_id,AGCY_ORI from incidentpeople
            where pd_id in
              (
                select pd_id from sjs.persondetail where pm_id=:old.pm_id
              )
          )
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
  end loop;
  
  
  for i in   (
          select I_ID,I_AGCY_ORI from arrestcharges
          where (A_id,AGCY_ORI)
          IN
          (
          select A_id,AGCY_ORI from arrestpeople
          where pd_id in
          (
          select pd_id from sjs.persondetail where pm_id=:old.pm_id
          )
          )
        )
   loop
   insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
   end loop;
   
   
   for i in (
          select I_ID,I_AGCY_ORI from warrantcharges
          where (w_id,AGCY_ORI)
          IN
          (
          select w_id,AGCY_ORI from warrantpeople
          where pd_id in
          (
          select pd_id from sjs.persondetail where pm_id=:old.pm_id
          )
          )
        )
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.AN_NYDEX_DELETE
BEFORE DELETE ON SJS.ARRESTNARRATIVE
FOR EACH ROW
BEGIN
  for i in (select i_id,i_agcy_ori from sjs.arrestcharges where a_id=:old.a_id and i_agcy_ori=:old.agcy_ori)
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.AN_NYDEX_INSERT
BEFORE INSERT ON SJS.ARRESTNARRATIVE
FOR EACH ROW
BEGIN
   for i in (select i_id,i_agcy_ori from sjs.arrestcharges where a_id=:new.a_id and i_agcy_ori=:new.agcy_ori)
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.AP_NYDEX_DELETE
BEFORE DELETE ON SJS.ARRESTPEOPLE
FOR EACH ROW
BEGIN
 
  for i in (select i_id,i_agcy_ori from sjs.arrestcharges where a_id =:old.a_id and agcy_ori=:old.agcy_ori)
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;

/
create or replace TRIGGER sjs.AW_NYDEX_DELETE
BEFORE DELETE ON SJS.ARRESTWEAPONS
for each row
BEGIN
  for i in (SELECT ac.i_id,ac.agcy_ori FROM sjs.arrestcharges ac WHERE ac.a_id = :old.a_id AND ac.agcy_ori = :old.agcy_ori)
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.AW_NYDEX_INSERT
BEFORE INSERT ON SJS.ARRESTWEAPONS
FOR EACH ROW
BEGIN
  for i in (SELECT ac.i_id,ac.agcy_ori FROM sjs.arrestcharges ac WHERE ac.a_id = :old.a_id AND ac.agcy_ori = :old.agcy_ori)
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.AW_NYDEX_UPDATE
BEFORE UPDATE ON SJS.ARRESTWEAPONS
FOR EACH ROW
BEGIN
 for i in (SELECT ac.i_id,ac.agcy_ori FROM sjs.arrestcharges ac WHERE ac.a_id = :old.a_id AND ac.agcy_ori = :old.agcy_ori)
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.DISP_NYDEX_INSERT
BEFORE INSERT ON SJS.DISPATCH
FOR EACH ROW
BEGIN
  for i in (select i_id,agcy_ori from sjs.incident where DISP_ID = :NEW.DISP_ID)
  loop
  insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null); 
  end loop;
END;
/

create or replace TRIGGER SJS.DISP_NYDEX_UPDATE
BEFORE UPDATE OF
       DISPATCHOFFICERID,
       DISPATCHERID,
       DISP_DISPATCHED,
       DISP_NOTES
       ON SJS.DISPATCH
       FOR EACH ROW
BEGIN
         for i in (select i_id,agcy_ori from sjs.incident where DISP_ID = :OLD.DISP_ID)
          loop
            insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null); 
          end loop;
END;
/

create or replace TRIGGER SJS.I_NYDEX_DELETE
before delete ON SJS.INCIDENT
Begin
   -- insert into NYDEX.NYDEX_MOD_LOG values (:old.I_id,'GREEN',null,1,'D',:old.AGCY_ORI,'N','N','N',null,null,null);
   NYDEX.NYDEX_AVOID_MUTATE.oldvals := NYDEX.NYDEX_AVOID_MUTATE.empty;
End;
/

create or replace TRIGGER SJS.I_NYDEX_DELETE_AD
 AFTER DELETE ON SJS.INCIDENT
BEGIN
  for i in 1 .. NYDEX.NYDEX_AVOID_MUTATE.oldvals.count
  loop
    insert into nydex.nydex_mod_log values NYDEX.NYDEX_AVOID_MUTATE.oldvals(i);
  end loop;
END;
/

create or replace TRIGGER SJS.I_NYDEX_DELETE_DDFER
 BEFORE DELETE ON SJS.INCIDENT
FOR EACH ROW
declare
        i    number default NYDEX.NYDEX_AVOID_MUTATE.oldvals.count+1;
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).i_id := :old.i_id;
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).security_flag:='GREEN';
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).batchno := null;
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).block_num := 1;
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).operation := 'D';
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).agcy_ori := :old.agcy_ori;
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).process_status := 'N';
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).security_flag_status := 'N';
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).raw_xml_creation_status:='N';
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).sealed_pk_id := null;
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).seal_type:=null;
  NYDEX.NYDEX_AVOID_MUTATE.oldvals(i).process_status_log :=null;
END;
/

create or replace TRIGGER SJS.I_NYDEX_INSERT
AFTER Insert ON SJS.INCIDENT
FOR EACH ROW
Begin
   insert into NYDEX.NYDEX_MOD_LOG values (:new.I_id,'GREEN',null,1,'I',:new.AGCY_ORI,'N','N','N',null,null,null);
End;
/

create or replace TRIGGER SJS.I_NYDEX_UPDATE
BEFORE UPDATE ON SJS.INCIDENT
FOR EACH ROW
BEGIN
         SELECT SYSDATE INTO :NEW.I_NYDEX_MOD_DATE FROM DUAL;
         insert into NYDEX.NYDEX_MOD_LOG values (:new.I_id,'GREEN',null,1,'M',:new.AGCY_ORI,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.IC_NYDEX_DELETE
before DELETE ON SJS.INCIDENTCHARGES
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.o := NYDEX.NYDEX_AVOID_MUTATE.n;
END;
/

create or replace TRIGGER SJS.IC_NYDEX_DELETE_AD
AFTER DELETE ON SJS.INCIDENTCHARGES
BEGIN
  for i in 1 .. NYDEX.NYDEX_AVOID_MUTATE.o.count
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id,'GREEN',null,1,'M',NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.IC_NYDEX_DELETE_DFFER
before DELETE ON SJS.INCIDENTCHARGES
for each row
declare
i    number default NYDEX.NYDEX_AVOID_MUTATE.o.count+1;
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id:=:old.i_id;
  NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori:=:old.agcy_ori;
END;
/

create or replace TRIGGER SJS.IC_NYDEX_INSERT
BEFORE INSERT ON SJS.INCIDENTCHARGES
FOR EACH ROW
BEGIN
         insert into NYDEX.NYDEX_MOD_LOG values (:NEW.I_ID,'GREEN',null,1,'M',:NEW.AGCY_ORI,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.IC_NYDEX_UPDATE
BEFORE UPDATE OF
    LAW_ORDINAL,
    IC_ATTEMPT,
    IC_COUNTS,
    LARCENYTHEFTID,
    ASSAULTHOMICIDEID,
    JUSTIFIABLEHOMICIDEID,
    ENTRYMETHOD,
    IC_NUM_PREMISIS
    ON SJS.INCIDENTCHARGES
    FOR EACH ROW
BEGIN
      insert into NYDEX.NYDEX_MOD_LOG values (:OLD.I_ID,'GREEN',null,1,'M',:OLD.AGCY_ORI,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.IN_NYDEX_DELETE
BEFORE DELETE ON SJS.INCIDENTNARRATIVE
BEGIN
   NYDEX.NYDEX_AVOID_MUTATE.o := NYDEX.NYDEX_AVOID_MUTATE.n;
END;
/

create or replace TRIGGER SJS.IN_NYDEX_DELETE_AD
AFTER DELETE ON SJS.INCIDENTNARRATIVE
BEGIN
  for i in 1 .. NYDEX.NYDEX_AVOID_MUTATE.o.count
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id,'GREEN',null,1,'M',NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.IN_NYDEX_DELETE_BDFER
before DELETE ON SJS.INCIDENTNARRATIVE
for each row
declare
i    number default NYDEX.NYDEX_AVOID_MUTATE.o.count+1;
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id:=:old.i_id;
  NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori:=:old.agcy_ori;
END;
/

create or replace TRIGGER SJS.IN_NYDEX_INSERT
BEFORE INSERT ON SJS.INCIDENTNARRATIVE
for each row
BEGIN
  insert into NYDEX.NYDEX_MOD_LOG values (:NEW.I_ID,'GREEN',null,1,'M',:NEW.agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER sjs.IOFW_NYDEX_DELETE
 BEFORE DELETE ON sjs.INCIDENTOFFENSEWEAPONS
FOR EACH ROW
BEGIN
  for i  in (SELECT ic.i_id,ic.agcy_ori FROM sjs.incidentcharges ic WHERE ic.ic_id =  :old.ic_id)
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.IOFW_NYDEX_INSERT
BEFORE INSERT ON SJS.INCIDENTOFFENSEWEAPONS
FOR EACH ROW
BEGIN
  for i  in (SELECT ic.i_id,ic.agcy_ori FROM sjs.incidentcharges ic WHERE ic.ic_id =  :NEW.ic_id)
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/


create or replace TRIGGER SJS.IOFW_NYDEX_UPDATE
BEFORE UPDATE ON SJS.INCIDENTOFFENSEWEAPONS
FOR EACH ROW
BEGIN
  for i  in (SELECT ic.i_id,ic.agcy_ori FROM sjs.incidentcharges ic WHERE ic.ic_id =  :old.ic_id)
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/


create or replace TRIGGER SJS.IP_NYDEX_INSERT
AFTER INSERT ON SJS.INCIDENTPEOPLE
for each row
BEGIN
  insert into NYDEX.NYDEX_MOD_LOG values (:new.i_id,'GREEN',null,1,'M',:new.agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.IPROP_NYDEX_DELETE
BEFORE DELETE ON SJS.INCIDENTPROPERTY
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.o := NYDEX.NYDEX_AVOID_MUTATE.n;
END;
/

create or replace TRIGGER SJS.IPROP_NYDEX_DELETE_Ad
AFTER DELETE ON SJS.INCIDENTPROPERTY
BEGIN
  for i in 1 .. NYDEX.NYDEX_AVOID_MUTATE.o.count
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id,'GREEN',null,1,'M',NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.IPROP_NYDEX_DELETE_DFFER
before DELETE ON SJS.INCIDENTPROPERTY
for each row
declare
i    number default NYDEX.NYDEX_AVOID_MUTATE.o.count+1;
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id:=:old.i_id;
  NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori:=:old.agcy_ori;
END;
/

create or replace TRIGGER SJS.IPROP_NYDEX_INSERT
BEFORE INSERT ON SJS.INCIDENTPROPERTY
FOR EACH ROW
BEGIN
      insert into NYDEX.NYDEX_MOD_LOG values (:new.i_id,'GREEN',null,1,'M',:new.agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.IPROP_NYDEX_UPDATE
BEFORE UPDATE OF
       PROPERTYSTATUSID,
       PROPERTYTYPEID,
       IPROP_MODEL,
       IPROP_SERIAL,
       IPROP_VALUE,
       DRUGTYPEID,
       IPROP_QTY,
       DRUGMEASUREID,
       IPROP_DESC,
       RECOVERYDATE
       ON SJS.INCIDENTPROPERTY
       FOR EACH ROW
BEGIN
       insert into NYDEX.NYDEX_MOD_LOG values (:old.i_id,'GREEN',null,1,'M',:old.agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.IV_NYDEX_DELETE
BEFORE DELETE ON SJS.INCIDENTVEHICLES
BEGIN
   NYDEX.NYDEX_AVOID_MUTATE.o := NYDEX.NYDEX_AVOID_MUTATE.n;
END;
/

create or replace TRIGGER SJS.IV_NYDEX_DELETE_AD
AFTER DELETE ON SJs.INCIDENTVEHICLES
BEGIN
  for i in 1 .. NYDEX.NYDEX_AVOID_MUTATE.o.count
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id,'GREEN',null,1,'M',NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.IV_NYDEX_DELETE_BDFER
before DELETE ON SJS.INCIDENTVEHICLES
for each row
declare
i    number default NYDEX.NYDEX_AVOID_MUTATE.o.count+1;
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id:=:old.i_id;
  NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori:=:old.agcy_ori;
END;
/

create or replace TRIGGER SJS.IV_NYDEX_INSERT
BEFORE INSERT ON SJS.INCIDENTVEHICLES
       FOR EACH ROW
BEGIN
       insert into NYDEX.NYDEX_MOD_LOG values (:new.i_id,'GREEN',null,1,'M',:new.agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.IV_NYDEX_UPDATE
BEFORE UPDATE OF
       VEHICLESTATUSID,
       VEHICLETYPEID,
       IV_VALUE,
       IV_YEAR,
       STYLEID,
       IV_VIN,
       IV_LICENSE_PLATE,
       IV_LICPL_STATUS,
       STATEID,
       IV_LICPL_EXPIRE,
       IV_NOTES,
       IV_RECOVDATE,
       VEHICLE_PRIMARY_COLOR_CODE,
       VEHICLE_SECONDARY_COLOR_CODE,
       VEHICLE_MAKE_CODE,
       VEHICLE_MODEL_CODE,
       LICENSE_PLATE_TYPE,
       AGCY_ORI
       ON SJS.INCIDENTVEHICLES
       FOR EACH ROW
BEGIN
  insert into NYDEX.NYDEX_MOD_LOG values (:OLD.i_id,'GREEN',null,1,'M',:OLD.agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.IW_NYDEX_DELETE
BEFORE DELETE ON SJS.INCIDENTWEAPONS
BEGIN
 NYDEX.NYDEX_AVOID_MUTATE.o := NYDEX.NYDEX_AVOID_MUTATE.n;
END;
/

create or replace TRIGGER SJS.IW_NYDEX_DELETE_AD
AFTER DELETE ON SJS.INCIDENTWEAPONS
BEGIN
  for i in 1 .. NYDEX.NYDEX_AVOID_MUTATE.o.count
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id,'GREEN',null,1,'M',NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.IW_NYDEX_DELETE_BDFER
before DELETE ON SJS.INCIDENTWEAPONS
for each row
declare
i    number default NYDEX.NYDEX_AVOID_MUTATE.o.count+1;
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id:=:old.i_id;
  NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori:=:old.agcy_ori;
END;
/

create or replace TRIGGER SJS.IW_NYDEX_INSERT
BEFORE INSERT ON SJS.INCIDENTWEAPONS
FOR EACH ROW
BEGIN
  insert into NYDEX.NYDEX_MOD_LOG values (:new.i_id,'GREEN',null,1,'M',:new.agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJs.IW_NYDEX_UPDATE
BEFORE UPDATE ON SJS.INCIDENTWEAPONS
FOR EACH ROW
BEGIN
 insert into NYDEX.NYDEX_MOD_LOG values (:new.i_id,'GREEN',null,1,'M',:new.agcy_ori,'N','N','N',null,null,null);
END;
/

create or replace TRIGGER SJS.N_NYDEX_INSERT
AFTER INSERT ON SJS.NARRATIVE
FOR EACH ROW
BEGIN
         for i in (SELECT I_ID,agcy_ori FROM SJS.INCIDENTNARRATIVE WHERE N_ID=:NEW.N_ID)
         loop
         insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
         end loop;
END;
/

create or replace TRIGGER SJS.N_NYDEX_UPDATE
BEFORE UPDATE --OF N_DATE_WRITTEN,N_TEXT,N_TEXT_CLOB
       ON SJS.NARRATIVE
FOR EACH ROW
BEGIN
         
         
         for i in (SELECT I_ID,agcy_ori FROM SJS.INCIDENTNARRATIVE WHERE N_ID=:NEW.N_ID)
         loop
         insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
         end loop;

         --updateing all incidents corresponds to warrant after warrant narrative updates.

          
          for i  in (
                      select i_id,i_agcy_ori from sjs.warrantcharges where w_id
                      in (select w_id from sjs.warrantnarrative where n_id=:old.n_id)
                    )
          loop
            insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
          end loop;

         --updating all incidents ,which corresponds to arrest after arrest narrative updates.

        for i in (
                  select i_id,i_agcy_ori from sjs.arrestcharges where a_id
                  in
                  (select a_id from sjs.arrestnarrative where n_id=:old.n_id)
                  )
        loop
            insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
        end loop;

END;
/



create or replace TRIGGER SJS.PD_NYDEX_INSERT
BEFORE INSERT ON SJS.PERSONDETAIL
FOR EACH ROW
BEGIN
       
        for i  in (SELECT I_ID,AGCY_ORI FROM SJS.INCIDENTPEOPLE IP WHERE IP.PD_ID=:NEW.PD_ID)
        loop
            insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
        end loop;
  
         --FOR ARREST PEOPLE
                
         for i in (
                  SELECT I_ID,I_AGCY_ORI FROM SJS.ARRESTCHARGES
                  WHERE (A_ID,AGCY_ORI) IN
                  (SELECT A_ID,AGCY_ORI FROM ARRESTPEOPLE WHERE PD_ID=:NEW.PD_ID)
                  )
        loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
        end loop;


         --FOR WARRANT PEOPLE
             
        for i  in (
                    SELECT I_ID,I_AGCY_ORI FROM SJS.WARRANTCHARGES
                    WHERE (W_ID,AGCY_ORI) IN
                    (SELECT W_ID,AGCY_ORI FROM WARRANTPEOPLE WHERE PD_ID=:NEW.PD_ID)
                  )
        loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
        end loop;
END;
/

create or replace TRIGGER SJS.PD_NYDEX_UPDATE
BEFORE UPDATE OF
       CAUTIONID,
       PD_AGERANGE,
       PERSONTYPEID,
       POB_ID,
       PD_SEX,
       PD_GLASSES,
       RACEID,
       CITIZENSHIPID,
       RELIGIONID,
       MARITALSTATUSID,
       ETHNICID,
       SKINID,
       CONDITIONID,
       OCCUPATIONID,
       PD_HEIGHT,
       PD_WEIGHT,
       HAIRID,
       EYESID,
       PD_BEARD,
       PD_MOUSTACHE,
       BUILDID,
       PD_SCARS,
       PD_MARKS,
       PD_TATTOOS,
       PD_DESCRIPTION,
       HANDICAPID,
       RESIDENCEID,
       VICTIMTYPEID,
       INJURYLEVELID,
       MEDICALTREATMENTID,
       PD_INJTYPE_1,
       PD_RESIDENCE_PCT,
       PD_PLATE_STATE,
       PD_DL_STATE,
       PD_DL_YEAR,
       PD_DL_NUMBER,
       PD_PLATE_NUM
       ON SJS.PERSONDETAIL
       FOR EACH ROW
BEGIN
       

        for i  in (SELECT I_ID,AGCY_ORI FROM SJS.INCIDENTPEOPLE IP WHERE IP.PD_ID=:OLD.PD_ID)
        loop
            insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
        end loop;
        
        
          --FOR ARREST PEOPLE
      
        for i in (
                  SELECT I_ID,I_AGCY_ORI FROM SJS.ARRESTCHARGES
                  WHERE (A_ID,AGCY_ORI) IN
                  (SELECT A_ID,AGCY_ORI FROM ARRESTPEOPLE WHERE PD_ID=:OLD.PD_ID)
                  )
        loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
        end loop;

         --FOR WARRANT PEOPLE
        
         for i  in (
                    SELECT I_ID,I_AGCY_ORI FROM SJS.WARRANTCHARGES
                    WHERE (W_ID,AGCY_ORI) IN
                    (SELECT W_ID,AGCY_ORI FROM WARRANTPEOPLE WHERE PD_ID=:OLD.PD_ID)
                  )
        loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
        end loop;
END;
/

create or replace TRIGGER SJS.PH_NYDEX_DELETE
BEFORE DELETE
ON SJS.personphoto
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
         
         for i in
         (SELECT IP.I_ID,IP.AGCY_ORI FROM SJS.INCIDENTPEOPLE IP WHERE IP.PD_ID IN
		(SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID=:OLD.PD_ID)
         )
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
         end loop;

         --for warrantpeople

         
         for i in (
         SELECT I_ID,I_AGCY_ORI FROM WARRANTCHARGES WHERE (W_ID,AGCY_ORI) IN
         (
         SELECT WP.W_ID,WP.AGCY_ORI FROM SJS.WARRANTPEOPLE WP WHERE WP.PD_ID IN
		(SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID=:OLD.PD_ID)
         )
         )
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
         end loop;

        --for warrantpeople

         
         for i in 
         (
         SELECT I_ID,I_AGCY_ORI FROM ARRESTCHARGES WHERE (A_ID,AGCY_ORI) IN
         (
         SELECT AP.A_ID,AP.AGCY_ORI FROM SJS.ARRESTPEOPLE AP WHERE AP.PD_ID IN
		(SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID=:OLD.PD_ID)
         )
         )
         loop
         insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
         end loop;
END;
/

create or replace TRIGGER SJS.PH_NYDEX_INSERT
BEFORE INSERT ON SJS.PERSONPHOTO
FOR EACH ROW
BEGIN
         
         for i in
         (SELECT IP.I_ID,IP.AGCY_ORI FROM SJS.INCIDENTPEOPLE IP WHERE IP.PD_ID IN
		(SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID=:NEW.PD_ID)
         )
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
         end loop;

         --for warrantpeople

         
         for i in (
         SELECT I_ID,I_AGCY_ORI FROM WARRANTCHARGES WHERE (W_ID,AGCY_ORI) IN
         (
         SELECT WP.W_ID,WP.AGCY_ORI FROM SJS.WARRANTPEOPLE WP WHERE WP.PD_ID IN
		(SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID=:NEW.PD_ID)
         )
         )
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
         end loop;

        --for warrantpeople

         
         for i in 
         (
         SELECT I_ID,I_AGCY_ORI FROM ARRESTCHARGES WHERE (A_ID,AGCY_ORI) IN
         (
         SELECT AP.A_ID,AP.AGCY_ORI FROM SJS.ARRESTPEOPLE AP WHERE AP.PD_ID IN
		(SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID=:NEW.PD_ID)
         )
         )
         loop
         insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
         end loop;
END;
/
create or replace TRIGGER SJS.PH_NYDEX_UPDATE
BEFORE UPDATE ON SJS.personphoto
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
         
         for i in
         (SELECT IP.I_ID,IP.AGCY_ORI FROM SJS.INCIDENTPEOPLE IP WHERE IP.PD_ID IN
		(SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID=:OLD.PD_ID)
         )
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
         end loop;

         --for warrantpeople

         
         for i in (
         SELECT I_ID,I_AGCY_ORI FROM WARRANTCHARGES WHERE (W_ID,AGCY_ORI) IN
         (
         SELECT WP.W_ID,WP.AGCY_ORI FROM SJS.WARRANTPEOPLE WP WHERE WP.PD_ID IN
		(SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID=:OLD.PD_ID)
         )
         )
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
         end loop;

        --for warrantpeople

         
         for i in 
         (
         SELECT I_ID,I_AGCY_ORI FROM ARRESTCHARGES WHERE (A_ID,AGCY_ORI) IN
         (
         SELECT AP.A_ID,AP.AGCY_ORI FROM SJS.ARRESTPEOPLE AP WHERE AP.PD_ID IN
		(SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID=:OLD.PD_ID)
         )
         )
         loop
         insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
         end loop;
END;
/

create or replace TRIGGER SJS.PM_NYDEX_INSERT
AFTER INSERT ON SJS.PERSONMASTER
FOR EACH ROW
BEGIN
        
         for i in (
		SELECT IP.I_ID,IP.AGCY_ORI FROM SJS.INCIDENTPEOPLE IP WHERE IP.PD_ID IN
		(
                       SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PM_ID =:NEW.PM_ID AND AGCY_ORI = :NEW.AGCY_ORI
		)
	)
        loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
        end loop;
        
                      
        --FOR ARRESTPEOPLE

       
       for i  in  (
		SELECT AC.I_ID,AC.I_AGCY_ORI FROM ARRESTCHARGES AC
                WHERE (AC.A_ID,AC.AGCY_ORI)
                IN
                (
                SELECT AP.A_ID,AP.AGCY_ORI FROM SJS.ARRESTPEOPLE AP WHERE AP.PD_ID IN
		(
                       SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PM_ID =:NEW.PM_ID AND AGCY_ORI = :NEW.AGCY_ORI
		)
                )
	)
        loop
        insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
        end loop
        ;
        
       
        --FOR WARRANTPEOPLE

       
        for i in
         (
		SELECT WC.I_ID,WC.I_AGCY_ORI FROM WARRANTCHARGES WC
                WHERE (WC.W_ID,WC.AGCY_ORI)
                IN
                (
                SELECT WP.W_ID,WP.AGCY_ORI FROM SJS.WARRANTPEOPLE WP WHERE WP.PD_ID IN
		(
                       SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PM_ID =:NEW.PM_ID AND AGCY_ORI = :NEW.AGCY_ORI
		)
                )
	)
        loop
        insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
        end loop;

END;
/

create or replace TRIGGER SJS.PM_NYDEX_UPDATE
BEFORE UPDATE OF
       PM_LAST_NAME,
       PM_FIRST_NAME,
       PM_MIDDLE_NAME,
       PM_BUSINESS_NAME,
       PM_SUFFIX,
       PM_DOB,
       PM_SSN,
       PM_FBI,
       PM_NYSID
       ON SJS.PERSONMASTER
       FOR EACH ROW

BEGIN
        for i in (
		SELECT IP.I_ID,IP.AGCY_ORI FROM SJS.INCIDENTPEOPLE IP WHERE IP.PD_ID IN
		(
			SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PM_ID =:OLD.PM_ID AND AGCY_ORI = :OLD.AGCY_ORI
		)
	)
        loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
        end loop;


        --FOR ARRRESTPEOPLE
       
        for i in (
		SELECT AC.I_ID,AC.I_AGCY_ORI FROM ARRESTCHARGES AC
                WHERE (AC.A_ID,AC.AGCY_ORI)
                IN
                (
                SELECT AP.A_ID,AP.AGCY_ORI FROM SJS.ARRESTPEOPLE AP WHERE AP.PD_ID IN
		(
                       SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PM_ID =:NEW.PM_ID AND AGCY_ORI = :OLD.AGCY_ORI
		)
                )
	)
        loop
        insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
        end loop;

        --FOR WARRANTPEOPLE

         for i  in (
		SELECT WC.I_ID,WC.I_AGCY_ORI FROM WARRANTCHARGES WC
                WHERE (WC.W_ID,WC.AGCY_ORI)
                IN
                (
                SELECT WP.W_ID,WP.AGCY_ORI FROM SJS.WARRANTPEOPLE WP WHERE WP.PD_ID IN
		(
                       SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PM_ID =:NEW.PM_ID AND AGCY_ORI = :OLD.AGCY_ORI
		)
                )
	)
        loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.I_AGCY_ORI,'N','N','N',null,null,null);
        end loop;
END;
/

create or replace TRIGGER SJS.PP_NYDEX_INSERT
BEFORE INSERT ON SJS.PERSONPHONE
FOR EACH ROW
BEGIN
        for i in 
        (
                SELECT IP.I_ID,IP.AGCY_ORI FROM SJS.INCIDENTPEOPLE IP WHERE IP.PD_ID IN
		(SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID=:NEW.PD_ID)
         )
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
         end loop;


         --FOR ARREST PEOPLE
       
        for i in (
		SELECT AC.I_ID,AC.I_AGCY_ORI FROM ARRESTCHARGES AC
                WHERE (AC.A_ID,AC.AGCY_ORI)
                IN
                (
                SELECT AP.A_ID,AP.AGCY_ORI FROM SJS.ARRESTPEOPLE AP WHERE AP.PD_ID IN
		(
                       SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID =:NEW.PD_ID
		)
                )
	)
        loop
        insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
        end loop;

        --FOR WARRANTPEOPLE

       
        for i in (
		SELECT WC.I_ID,WC.I_AGCY_ORI FROM WARRANTCHARGES WC
                WHERE (WC.W_ID,WC.AGCY_ORI)
                IN
                (
                SELECT WP.W_ID,WP.AGCY_ORI FROM SJS.WARRANTPEOPLE WP WHERE WP.PD_ID IN
		(
                       SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID =:NEW.PD_ID
		)
                )
	)
        loop
        insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
        end loop;
END;
/

create or replace TRIGGER SJS.PP_NYDEX_UPDATE
BEFORE UPDATE OF
       PP_PHONE_NUMBER,
       PHONETYPEID,
       PP_EXTENSION
       ON SJS.PERSONPHONE
       FOR EACH ROW
BEGIN
       
        for i in 
        (
                SELECT IP.I_ID,IP.AGCY_ORI FROM SJS.INCIDENTPEOPLE IP WHERE IP.PD_ID IN
		(SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID=:OLD.PD_ID)
         )
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
         end loop;


         --FOR ARREST PEOPLE
       
        for i in (
		SELECT AC.I_ID,AC.I_AGCY_ORI FROM ARRESTCHARGES AC
                WHERE (AC.A_ID,AC.AGCY_ORI)
                IN
                (
                SELECT AP.A_ID,AP.AGCY_ORI FROM SJS.ARRESTPEOPLE AP WHERE AP.PD_ID IN
		(
                       SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID =:OLD.PD_ID
		)
                )
	)
        loop
        insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
        end loop;

        --FOR WARRANTPEOPLE

       
        for i in (
		SELECT WC.I_ID,WC.I_AGCY_ORI FROM WARRANTCHARGES WC
                WHERE (WC.W_ID,WC.AGCY_ORI)
                IN
                (
                SELECT WP.W_ID,WP.AGCY_ORI FROM SJS.WARRANTPEOPLE WP WHERE WP.PD_ID IN
		(
                       SELECT PD.PD_ID FROM SJS.PERSONDETAIL PD WHERE PD.PD_ID =:OLD.PD_ID
		)
                )
	)
        loop
        insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
        end loop;
END;
/

create or replace TRIGGER SJS.VS_NYDEX_DELETE
BEFORE DELETE ON SJS.VICTIMSUSPECT
BEGIN
 NYDEX.NYDEX_AVOID_MUTATE.o := NYDEX.NYDEX_AVOID_MUTATE.n;
END;
/

create or replace TRIGGER SJS.VS_NYDEX_DELETE_AD
AFTER DELETE ON SJS.VICTIMSUSPECT
FOR EACH ROW
BEGIN
for i in 1 .. NYDEX.NYDEX_AVOID_MUTATE.o.count
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id,'GREEN',null,1,'M',NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.VS_NYDEX_DELETE_BDFER
BEFORE DELETE ON SJS.VICTIMSUSPECT
FOR EACH ROW
declare
i    number default NYDEX.NYDEX_AVOID_MUTATE.o.count+1;
ori varchar2(9);
iid number(23);
BEGIN
  for j in ( SELECT i_id,agcy_ori into iid,ori FROM incidentpeople WHERE ip_id = :old.ip_victim_id OR ip_id = :old.ip_suspect_id)
  loop
    NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id:=j.i_id;
    NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori:=j.agcy_ori;
  end loop;
END;
/

create or replace TRIGGER SJS.VS_NYDEX_INSERT
BEFORE INSERT ON SJS.VICTIMSUSPECT
FOR EACH ROW
BEGIN
         for i IN (SELECT i_id,agcy_ori FROM INCIDENTPEOPLE WHERE IP_ID = :NEW.IP_VICTIM_ID OR IP_ID = :NEW.IP_SUSPECT_ID)
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
         end loop;
END;
/

create or replace TRIGGER SJS.VS_NYDEX_UPDATE
BEFORE UPDATE OF
       RELATIONSHIPID
       ON SJS.VICTIMSUSPECT
       FOR EACH ROW
BEGIN
         for i IN (SELECT i_id,agcy_ori FROM INCIDENTPEOPLE WHERE IP_ID = :OLD.IP_VICTIM_ID OR IP_ID = :OLD.IP_SUSPECT_ID)
         loop
         insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.agcy_ori,'N','N','N',null,null,null);
         end loop;
END;
/

create or replace TRIGGER SJS.W_NYDEX_INSERT
BEFORE INSERT ON SJS.WARRANT
FOR EACH ROW
BEGIN
         for i IN (SELECT I_ID,i_agcy_ori FROM WARRANTCHARGES WHERE W_ID = :NEW.W_ID AND AGCY_ORI = :NEW.AGCY_ORI)
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
         end loop;
END;
/

create or replace TRIGGER SJS.W_NYDEX_UPDATE
BEFORE UPDATE ON SJS.WARRANT
FOR EACH ROW
BEGIN
         for i  IN (SELECT I_ID,i_agcy_ori FROM WARRANTCHARGES WHERE W_ID = :OLD.W_ID AND AGCY_ORI = :OLD.AGCY_ORI)
         loop
          insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
         end loop;
END;
/

create or replace TRIGGER SJs.WC_NYDEX_DELETE
BEFORE DELETE ON SJS.WARRANTCHARGES
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.o := NYDEX.NYDEX_AVOID_MUTATE.n;
END;
/

create or replace TRIGGER SJS.WC_NYDEX_DELETE_AD
AFTER DELETE ON SJS.WARRANTCHARGES
BEGIN
  for i in 1 .. NYDEX.NYDEX_AVOID_MUTATE.o.count
  loop
      insert into NYDEX.NYDEX_MOD_LOG values (NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id,'GREEN',null,1,'M',NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJs.WC_NYDEX_DELETE_BDFER
before DELETE ON SJS.WARRANTCHARGES
for each row
declare
i    number default NYDEX.NYDEX_AVOID_MUTATE.o.count+1;
BEGIN
  NYDEX.NYDEX_AVOID_MUTATE.o(i).i_id:=:old.i_id;
  NYDEX.NYDEX_AVOID_MUTATE.o(i).agcy_ori:=:old.agcy_ori;
END;
/

create or replace TRIGGER SJS.WC_NYDEX_INSERT
BEFORE INSERT ON SJS.WARRANTCHARGES
FOR EACH ROW
BEGIN
 for i in (select i_id,i_agcy_ori from sjs.warrantcharges where w_id=:NEW.w_id)
 loop
  insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
 end loop;
END;
/

create or replace TRIGGER SJS.WC_NYDEX_UPDATE
BEFORE UPDATE ON SJS.WARRANTCHARGES
FOR EACH ROW
BEGIN
  for i in (select i_id,i_agcy_ori from sjs.warrantcharges where w_id=:OLD.w_id)
  loop
  insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
 end loop;
END;
/


create or replace TRIGGER SJS.WN_NYDEX_DELETE
BEFORE DELETE ON SJS.WARRANTNARRATIVE
FOR EACH ROW
BEGIN
  for i  in
  (select i_id,i_agcy_ori from sjs.warrantcharges where w_id=:old.w_id and i_agcy_ori=:old.agcy_ori)
  loop
  insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.WN_NYDEX_INSERT
 BEFORE INSERT ON SJS.WARRANTNARRATIVE
FOR EACH ROW
BEGIN
  for i in   (SELECT I_ID,I_AGCY_ORI from SJS.WARRANTCHARGES where W_ID=:NEW.W_ID)
  loop
  insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/


create or replace TRIGGER SJS.WP_NYDEX_DELETE
BEFORE DELETE ON SJS.warrantpeople
FOR EACH ROW
BEGIN
 for i in
  (
  select i_id,i_agcy_ori from sjs.warrantcharges where w_id =:old.w_id and agcy_ori=:old.agcy_ori
  )
  loop
    insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/

create or replace TRIGGER SJS.WP_NYDEX_INSERT
AFTER INSERT ON SJS.WARRANTPEOPLE
FOR EACH ROW
BEGIN
 for i in
  (
  select i_id,i_agcy_ori from sjs.warrantcharges where w_id =:new.w_id and agcy_ori=:new.agcy_ori
  )
  loop
  insert into NYDEX.NYDEX_MOD_LOG values (i.i_id,'GREEN',null,1,'M',i.i_agcy_ori,'N','N','N',null,null,null);
  end loop;
END;
/







